// jpegthumbs.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "jpegfile.h"

#define parsefunction "ext=\"JPG\" | ext=\"JPEG\""

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

char* strlcpy(char* p,char*p2,int maxlen)
{
	if ((int)strlen(p2)>=maxlen) {
		strncpy(p,p2,maxlen);
		p[maxlen]=0;
	} else
		strcpy(p,p2);
	return p;
}

HWND __stdcall ListLoad(HWND ParentWin,char* FileToLoad,int ShowFlags)
{
	return NULL;   // only a preview plugin!
}

HBITMAP __stdcall ListGetPreviewBitmap(char* FileToLoad,int width,int height,
    char* contentbuf,int contentbuflen)
{
	BYTE *tmp;
	unsigned int m_widthDW;
	unsigned int m_width=width;
	unsigned int m_height=height;
	OSVERSIONINFO vx;
	BOOL is_nt,linesdoubled;
	
	// check for operating system:
	// Windows 9x does NOT support the HALFTONE stretchblt mode!
	vx.dwOSVersionInfoSize=sizeof(vx);
	GetVersionEx(&vx);
	is_nt=vx.dwPlatformId==VER_PLATFORM_WIN32_NT;

	if (is_nt) {
		m_width*=2;
		m_height*=2;
	}
	linesdoubled=is_nt;

	tmp=JpegFile::JpegFileToRGBThumb(FileToLoad, &m_width, &m_height,&linesdoubled);
	if (tmp==NULL) {      // load failed
		return NULL;
	}

	// do this before DWORD-alignment!!!
	// this works on packed (not DWORD-aligned) buffers
	// swap red and blue for display
	JpegFile::BGRFromRGB(tmp, m_width, m_height);

	// DWORD-align for display
	BYTE* m_buf = JpegFile::MakeDwordAlignedBuf(tmp,
									 m_width,
									 m_height,
									 &m_widthDW);

	delete [] tmp;

	// vertical flip for display
	JpegFile::VertFlipBuf(m_buf, m_widthDW, m_height);

	BITMAPINFO bi;
	HWND m_hWnd=GetDesktopWindow();
	HDC dc=GetDC(m_hWnd);
	POINT pt;
	unsigned char* bits;

	memset(&bi,0,sizeof(bi));
	bi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth=m_width;
	bi.bmiHeader.biHeight=m_height;
	bi.bmiHeader.biPlanes=1;
	bi.bmiHeader.biBitCount=24;
	bi.bmiHeader.biSizeImage=m_widthDW*m_height;
	bi.bmiHeader.biCompression = BI_RGB;
	HBITMAP m_hbmp=CreateDIBSection(dc,&bi,DIB_RGB_COLORS,(void**)&bits,NULL,0);
	if (m_hbmp) {
		memcpy(bits,m_buf,m_widthDW*m_height);
	}
	delete [] m_buf;

    if (linesdoubled) {
	    HDC dc_small=CreateCompatibleDC(dc);
	    HDC dc_big=CreateCompatibleDC(dc);
		width=m_width/2;
		height=m_height/2;
	    HBITMAP bmp_small=CreateCompatibleBitmap(dc,width,height);
		HBITMAP oldbmp_big=(HBITMAP)SelectObject(dc_big,m_hbmp);
		HBITMAP oldbmp_small=(HBITMAP)SelectObject(dc_small,bmp_small);
		SetStretchBltMode(dc_small,HALFTONE);
		SetBrushOrgEx(dc_small,0,0,&pt);
		StretchBlt(dc_small,0,0,width,height,dc_big,0,0,m_width,m_height,SRCCOPY);
		SelectObject(dc_small,oldbmp_small);
	    SelectObject(dc_big,oldbmp_big);
		DeleteObject(m_hbmp);
		m_hbmp=bmp_small;
    }

	ReleaseDC(m_hWnd,dc);
	return m_hbmp;
}

void __stdcall ListGetDetectString(char* DetectString,int maxlen)
{
	strlcpy(DetectString,parsefunction,maxlen);
}
